
//function setDefaultFullZoomLevel

var fullZoomBtn = {
  full: null,
  win : null,
  windowResizedTimer: null,
  //init
  init: function() {
    window.removeEventListener('load', this, false);
    window.addEventListener('unload', this, false);
    document.getElementById("appcontent").addEventListener("resize", this, false);

    fullZoomBtn.initPref();
    fullZoomBtn.lastInnerWidth = fullZoomBtn.calculateWidth();
    //fullZoomBtn.showZoomLevelInStatusbar(ZoomManager.zoom, ZoomManager.useFullZoom);

    // Bug 505312 -  After detach tab,The zoom level of the detached tab does not
    // synchronize until it reloads.(In the detached tab, onLocationChange does not
    // fire by switching tab until it reload.)
    var isFx35 = parseInt(Components.classes["@mozilla.org/xre/app-info;1"]
                     .getService(Components.interfaces.nsIXULAppInfo)
                     .version.substr(0,3) * 10, 10) / 10 > 3.0;
    if (isFx35)
      gBrowser.tabContainer.addEventListener('TabSelect', this, false);
  },

  uninit: function() {
    window.removeEventListener('unload', this, false);
    document.getElementById("appcontent").removeEventListener("resize", this, false);
    gBrowser.tabContainer.removeEventListener('TabSelect', this, false);
  },

  handleEvent: function(event){
    switch (event.type){
      case 'TabSelect':
        this.tabSelect(event);
        break;
      case 'resize':
        this.windowResized(event);
        break;
      case 'load':
        this.init(event);
        break;
      case 'unload':
        this.uninit(event);
    }
  },

  tabSelect: function(event){
    FullZoom.onLocationChange(event.target.linkedBrowser.currentURI, true, event.target.linkedBrowser);
  },

  //initPref
  initPref: function() {
    var statusbarZoomLevel = document.getElementById("statusbarZoomLevel");
    var showInStatusbar = this.getPref("extensions.browser.zoom.fullZoom.showinstatusbar", "bool" ,false);
    if (showInStatusbar)
      statusbarZoomLevel.removeAttribute("hidden");
    else
      statusbarZoomLevel.setAttribute("hidden", true);
  },

  //show Zoom Level In Statusbar
  showZoomLevelInStatusbar: function(){
    var statusbarZoomLevel = document.getElementById("statusbarZoomLevel");
    var label = Math.floor(ZoomManager.zoom * 100 + 0.5);
    if (ZoomManager.useFullZoom)
      label = "F"+label+"%";
    else
      label = "T"+label+"%";
    statusbarZoomLevel.setAttribute("label", label);
  },

  clickStatusLabel:function(evt) {
    if (evt.type == "DOMMouseScroll") {
      this.click(evt, ZoomManager.useFullZoom);
      return;
    }
    if (evt.button == 2/* || evt.button == 0 && evt.clientX- evt.target.boxObject.x  < 12*/) {
      evt.stopPropagation();
      evt.preventDefault();
      //トグルモード
      document.getElementById("cmd_fullZoomToggle").doCommand();
      return;
    }
    if (evt.button == 1) {
      // 標準サイズ
      document.getElementById("cmd_fullZoomReset").doCommand();
      return;
    }
    var btn = evt.target;
    this.full = ZoomManager.useFullZoom;
    var popup = document.getElementById("fullZoomBtn_popup");
    //toggle
    if (popup.status == "open")
      popup.hidePopup();
    else
      popup.openPopup(btn);
  },

  click: function(evt,fullZoom) {
    if (!!document.getElementById("textZoomBtn_popup2") &&
        document.getElementById("textZoomBtn_popup2").state=="open") {
      return;
    }
    if (!!document.getElementById("fullZoomBtn_popup2") &&
        document.getElementById("fullZoomBtn_popup2").state=="open") {
      return;
    }
    if (evt.type == "DOMMouseScroll") {
      if (evt.detail > 0) {
        // ページ縮小
        this.toggleZoom(fullZoom);
        document.getElementById("cmd_fullZoomReduce").doCommand();
      } else {
        // ページ拡大
        this.toggleZoom(fullZoom);
        document.getElementById("cmd_fullZoomEnlarge").doCommand();
      }
      return;
    }

    if (evt.button == 0 && evt.shiftKey) {
      evt.stopPropagation();
      var btn = evt.target;
      if (document.getElementById("fullzoombtn") == btn ||
          document.getElementById("fullzoombtn2") == btn )
        this.full = true;
      else if (document.getElementById("textzoombtn") == btn ||
          document.getElementById("textzoombtn2") == btn )
        this.full = false;
      var popup = document.getElementById("fullZoomBtn_popup");
      popup.openPopup(btn, "after_end");
    } else if (evt.button == 2 && evt.shiftKey) {
      this.openPrefWindow();
    } else {
      this.zoom(evt.button, fullZoom)
    }
    evt.preventDefault();
    evt.stopPropagation();
    return false;
  },

  zoom: function(type, fullZoom) {
    //AutoFit to Flase
    ZoomManager.useFullAuto = false;
    switch(type) {
      case 0:
        // ページ拡大
        this.toggleZoom(fullZoom);
        document.getElementById("cmd_fullZoomEnlarge").doCommand();
        break;
      case 1: // Middle Click
        // 標準サイズ
        this.toggleZoom(fullZoom);
        document.getElementById("cmd_fullZoomReset").doCommand();
        fullZoomBtn.showZoomLevelInStatusbar();
        break;
      case 2: // Right Click
        // ページ縮小
        this.toggleZoom(fullZoom);
        document.getElementById("cmd_fullZoomReduce").doCommand();
        break;
    }
  },

  toggleZoom: function ZoomManager_toggleZoom(useFullZoom) {
    var zoomLevel = ZoomManager.zoom;
    ZoomManager.useFullZoom = useFullZoom;
    ZoomManager.zoom = zoomLevel;
  },

  //option
  openPrefWindow: function () {
    window.openDialog(
      "chrome://DefaultFullZoomLevel/content/pref.xul", "DefaultFullZoomLevel:Setting",
      "chrome,titlebar,toolbar,centerscreen,modal"
    );
  },

  windowResized: function(event) {
    if (this.windowResizedTimer) {
      clearTimeout(this.windowResizedTimer);
      this.windowResizedTimer = null;
    }
    this.windowResizedTimer = setTimeout(function(self) {
      var width = self.calculateWidth();
      var diff = width - self.lastInnerWidth;
      if (Math.abs(diff) < 5)
        return;
      self.lastInnerWidth = width;
      if (FullZoom.globalAuto && !!ZoomManager.useFullAuto) {
        self.doFullZoomBy(-1, true);
      }
    },500, this);
  },

  calculateWidth: function() {
    //Reserve Sidebar Width
    var reservesidebar = this.getPref("extensions.browser.zoom.fullZoom.reserveSidebarWidth", "bool", false);
    var sidebarWidth = 0;
    var sidebarsplitterWidth = 0;
    var sidebarbox = document.getElementById("sidebar-box");
    var sidebar    = document.getElementById("sidebar");

    if (reservesidebar && sidebarbox.boxObject.width == 0) {

      sidebarWidth = Math.ceil(sidebarbox.width);
      if (!sidebarWidth)
        sidebarWidth = Math.ceil(document.defaultView.getComputedStyle(sidebar, '').
                        getPropertyValue('width').replace('px',''));

      var sidebarsplitter = document.getElementById("sidebar-splitter");
      if (sidebarsplitter.boxObject.width == 0)
        sidebarsplitterWidth = Math.ceil(document.defaultView.getComputedStyle(sidebarsplitter, '').
                                 getPropertyValue('min-width').replace('px',''));

      sidebarWidth = sidebarWidth + sidebarsplitterWidth;
    }
    //window width
//this.debug("content W= " + gBrowser.mPanelContainer.boxObject.width);
//this.debug("sidebar W= " + sidebarWidth);
    return gBrowser.mPanelContainer.boxObject.width - sidebarWidth;
  },

  //calculate zoom level for fit to window.
  getFitZoomLevel: function(useFullZoom, aBrowser, forceFit) {
    var doc = aBrowser.contentDocument;
    if (!doc.documentElement)
      return;
    //min max
    var minzoom = (this.getPref("extensions.browser.zoom.fitZoom.minimum", "int", 50)/100);
    var maxzoom = (this.getPref("extensions.browser.zoom.fitZoom.maximum", "int", 200)/100);

    ZoomManager.preserveTextSize =
            this.getPref("extensions.browser.zoom.fullZoom.fitToWidthPreserveTextSize", "bool", false);
    ZoomManager.useFullZoom = useFullZoom;

    //display width (include/exclude sidebar width)
    var width = this.calculateWidth();

    //scrollbar width
    var scw = Math.ceil((doc.defaultView.innerWidth - doc.documentElement.offsetWidth) *
              ZoomManager.getZoomForBrowser(aBrowser) ); ////ZoomManager.getZoom2(aTab) );
//this.debug("scroll W= " + scw);
    //display width exclude scrollbar width
    var ww = width - scw;

    //content width
    var hw = doc.documentElement.scrollWidth;
    var dw = (doc.body) ? doc.body.scrollWidth : hw;
    if (!(FullZoom.forceFitToWidth || forceFit) || ww > Math.max(hw,dw)) {
      changeZoom();
    } else {
      ZoomManager.setZoomForBrowser(aBrowser,
                                    (FullZoom.forceFitToWidth || forceFit)
                                     ? maxzoom
                                     : FullZoom.globalValue);
      setTimeout(function() {changeZoom();}, 0);
    }

    function changeZoom() {
      //content width
      var hw = doc.documentElement.scrollWidth;
      var dw = (doc.body) ? doc.body.scrollWidth : hw;
      var error = (FullZoom.forceFitToWidth || forceFit) ? 1.03: 1;
      var zoom = Math.floor(Math.floor((ww / (Math.max(hw,dw) * error)) * 20) * 5) / 100;
      zoom = Math.min(Math.max(zoom,minzoom),maxzoom);
      ZoomManager.useFullAuto = true;
      ZoomManager.useFullZoom = useFullZoom;
      ZoomManager.setZoomForBrowser(aBrowser, zoom);

      FullZoom._applySettingToPref();
    }
  },

  //Apply zoom level to current tab
  doFullZoomBy: function(zoom, useFullZoom, aBrowser, forceFit) {
    var browser = aBrowser || gBrowser.selectedBrowser;
    var ss = Components.classes["@mozilla.org/browser/sessionstore;1"].
                               getService(Components.interfaces.nsISessionStore);
    if (zoom < 0) {
      fullZoomBtn.getFitZoomLevel(useFullZoom, browser, forceFit);
      return;
    }

    ZoomManager.useFullAuto = false;
    ZoomManager.useFullZoom = useFullZoom;
    ZoomManager.setZoomForBrowser(browser, zoom);

    FullZoom._applySettingToPref();
  },

  //create popup menu
  onPopupShowing: function(event, useFullZoom) {
    //sort関数
    function cmp_val(a, b) {
      var aa = Math.floor(a);
      var bb = Math.floor(b);
      return  aa > bb ? -1 : 1;
    }
    var popup = event.target;
    while(popup.lastChild) {
      popup.removeChild(popup.lastChild);
    }

    if (typeof useFullZoom =='undefined') {
      useFullZoom = this.full;
    }
    var p = this.getPref("toolkit.zoomManager.zoomValues", "str", true);
    var s = p.split(',');
    s.sort(cmp_val);

    var arr=[];
    var zoom = Math.floor(ZoomManager.zoom * 100 + 0.5);
    for (var i=0; i<s.length; i++) {
      try{
        var x = Math.floor(s[i] * 100 + 0.5);
        if (x < zoom) {
          arr.push(zoom);
          zoom = 0;
        } else if (x == zoom) {
          zoom = 0;
        }
        arr.push(x);
      }catch(ex) {}
    }
    if (zoom != 0) {
      arr.push(zoom);
    }
    for (var i=0; i<arr.length; i++) {
      var menuitem = document.createElement('menuitem');
      var s = '    '+ (arr[i]).toString();
      menuitem.setAttribute('label',s.substr(s.length - 4, 4) + '%');
      menuitem.setAttribute('type','radio');
      menuitem.setAttribute('oncommand','fullZoomBtn.doFullZoomBy(' + arr[i]/100 + ', ' + useFullZoom + ');');
      if (!ZoomManager.useFullZoom == !useFullZoom &&
         arr[i] == Math.floor(ZoomManager.zoom * 100 + 0.5)) {
        menuitem.setAttribute('checked',true);
      }

      popup.appendChild(menuitem);
    }
    var bundle = document.getElementById("bundle_defaultfullzoomlevel");
    if (useFullZoom) {
      var menuitem = document.createElement('menuseparator');
      popup.appendChild(menuitem);

      var menuitem = document.createElement('menuitem');
      menuitem.setAttribute('label',bundle.getString('fitToWindow'));
      menuitem.setAttribute('oncommand','fullZoomBtn.doFullZoomBy( -1, ' + useFullZoom + ', null, true);');
      menuitem.setAttribute('type','checkbox');

      if ( FullZoom.globalAuto && !!ZoomManager.useFullAuto) {
        menuitem.setAttribute('checked',true);
      }
      popup.appendChild(menuitem);
    }
    var menuitem = document.createElement('menuseparator');
    popup.appendChild(menuitem);

    var menuitem = document.createElement('menuitem');
    menuitem.setAttribute('label',bundle.getString('reset'));
    var value = FullZoom.globalValue;
    menuitem.setAttribute('oncommand','fullZoomBtn.doFullZoomBy(' + value + ', '+ useFullZoom + ');');
    menuitem.setAttribute('type','checkbox');
    popup.appendChild(menuitem);
  },

  //prefを読み込み
  getPref: function(aPrefString, aPrefType, aDefault) {
    var xpPref = Components.classes['@mozilla.org/preferences-service;1']
                  .getService(Components.interfaces.nsIPrefService);
    try{
      switch (aPrefType) {
        case 'complex':
          return xpPref.getComplexValue(aPrefString, Components.interfaces.nsILocalFile); break;
        case 'str':
          return xpPref.getCharPref(aPrefString).toString(); break;
        case 'int':
          return xpPref.getIntPref(aPrefString); break;
        case 'bool':
        default:
          return xpPref.getBoolPref(aPrefString); break;
      }
    }catch(e) {
    }
    return aDefault;
  },
  //prefを書き込み
  setPref: function(aPrefString, aPrefType, aValue) {
    var xpPref = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch2);
    try{
      switch (aPrefType) {
        case 'complex':
          return xpPref.setComplexValue(aPrefString, Components.interfaces.nsILocalFile, aValue); break;
        case 'str':
          return xpPref.setCharPref(aPrefString, aValue); break;
        case 'int':
          aValue = parseInt(aValue);
          return xpPref.setIntPref(aPrefString, aValue);  break;
        case 'bool':
        default:
          return xpPref.setBoolPref(aPrefString, aValue); break;
      }
    }catch(e) {
    }
    return null;
  },
//Thanks Piro.
  // 監視を開始する
  addPrefListener: function(aObserver) {
      try {
          var pbi = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch2);
          pbi.addObserver(aObserver.domain, aObserver, false);
      } catch(e) {}
  },

  // 監視を終了する
  removePrefListener: function(aObserver) {
      try {
          var pbi = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch2);
          pbi.removeObserver(aObserver.domain, aObserver);
      } catch(e) {}
  },

  PrefListener:{
      domain  : 'extensions.browser.zoom.fullZoom.showinstatusbar',
          //'userChrome.ieview.XXX'という名前の設定が変更された場合全てで処理を行う

      observe : function(aSubject, aTopic, aPrefstring) {
          if (aTopic == 'nsPref:changed') {
              // 設定が変更された時の処理
              (function() {fullZoomBtn.initPref();})();
          }
      }
  },


  debug: function(aMsg) {
    const Cc = Components.classes;
    const Ci = Components.interfaces;
    Cc["@mozilla.org/consoleservice;1"]
      .getService(Ci.nsIConsoleService)
      .logStringMessage(aMsg);
  },

  //Fxのバージョン
  getVer: function() {
    const Cc = Components.classes;
    const Ci = Components.interfaces;
    var info = Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULAppInfo);
    var ver = parseInt(info.version.substr(0,3) * 10,10) / 10;
    return ver;
  }
};

//Initialize with new FullZoom
window.addEventListener("load", fullZoomBtn, false);
