//@line 42 "/e/builds/tinderbox/Fx-Trunk/WINNT_5.2_Depend/mozilla/toolkit/content/viewZoomOverlay.js"

/** Document Zoom Management Code
 *
 * To use this, you'll need to have a getBrowser() function.
 **/

ZoomManager = {
  useFullAuto: false,
  preserveTextSize: false,

  get _prefBranch ZoomManager_get__prefBranch() {
    delete this._prefBranch;
    return this._prefBranch = Components.classes["@mozilla.org/preferences-service;1"]
                                        .getService(Components.interfaces.nsIPrefBranch);
  },

  get MIN ZoomManager_get_MIN() {
    delete this.MIN;
    return this.MIN = this._prefBranch.getIntPref("zoom.minPercent") / 100;
  },

  get MAX ZoomManager_get_MAX() {
    delete this.MAX;
    return this.MAX = this._prefBranch.getIntPref("zoom.maxPercent") / 100;
  },

  get useFullZoom ZoomManager_get_useFullZoom() {
    return this._prefBranch.getBoolPref("browser.zoom.full");
  },

  set useFullZoom ZoomManager_set_useFullZoom(aVal) {
    this._prefBranch.setBoolPref("browser.zoom.full", aVal);
    return aVal;
  },

  get zoom ZoomManager_get_zoom() {
    return this.getZoomForBrowser(getBrowser());
  },

  getZoomForBrowser: function ZoomManager_getZoomForBrowser(aBrowser) {
    var markupDocumentViewer = aBrowser.markupDocumentViewer;

    return this.useFullZoom ? markupDocumentViewer.fullZoom
                            : markupDocumentViewer.textZoom;
  },

  getZoom2: function ZoomManager_get_zoom(aBrowser) {
    var markupDocumentViewer = aBrowser.markupDocumentViewer;

    return this.useFullZoom ? markupDocumentViewer.fullZoom
                            : markupDocumentViewer.textZoom;
  },

  set zoom ZoomManager_set_zoom(aVal) {
    this.setZoomForBrowser(getBrowser(), aVal);
    return aVal;
  },

  setZoomForBrowser: function ZoomManager_setZoomForBrowser(aBrowser, aVal) {
    if (aVal < this.MIN || aVal > this.MAX)
      throw Components.results.NS_ERROR_INVALID_ARG;

    var markupDocumentViewer = aBrowser.markupDocumentViewer;
    if (!markupDocumentViewer)
      return;

    if (this.useFullZoom) {
      if (this.preserveTextSize)
        markupDocumentViewer.textZoom = markupDocumentViewer.textZoom * markupDocumentViewer.fullZoom/aVal;
      else
        if (markupDocumentViewer.textZoom != 1) markupDocumentViewer.textZoom = 1;
      if (markupDocumentViewer.fullZoom != aVal) markupDocumentViewer.fullZoom = aVal;
    } else {
      if (markupDocumentViewer.textZoom != aVal) markupDocumentViewer.textZoom = aVal;
      if (markupDocumentViewer.fullZoom != 1) markupDocumentViewer.fullZoom = 1;
    }
  },

  zoom2: function ZoomManager_set_zoom(aVal, aBrowser) {  //aTab
    if (aVal < this.MIN || aVal > this.MAX)
      throw Components.results.NS_ERROR_INVALID_ARG;

    var markupDocumentViewer = aBrowser.markupDocumentViewer;
    if (!markupDocumentViewer)
      return;

    if (this.useFullZoom) {
      if (this.preserveTextSize)
        markupDocumentViewer.textZoom = markupDocumentViewer.textZoom * markupDocumentViewer.fullZoom/aVal;
      else
        if (markupDocumentViewer.textZoom != 1) markupDocumentViewer.textZoom = 1;
      if (markupDocumentViewer.fullZoom != aVal) markupDocumentViewer.fullZoom = aVal;
    } else {
      if (markupDocumentViewer.textZoom != aVal) markupDocumentViewer.textZoom = aVal;
      if (markupDocumentViewer.fullZoom != 1) markupDocumentViewer.fullZoom = 1;
    }

    return aVal;
  },

  get zoomValues ZoomManager_get_zoomValues() {
    var zoomValues = this._prefBranch.getCharPref("toolkit.zoomManager.zoomValues")
                                     .split(",").map(parseFloat);
    zoomValues.sort(function (a, b) a - b);

    while (zoomValues[0] < this.MIN)
      zoomValues.shift();

    while (zoomValues[zoomValues.length - 1] > this.MAX)
      zoomValues.pop();

    delete this.zoomValues;
    return this.zoomValues = zoomValues;
  },

  enlarge: function ZoomManager_enlarge() {
    this.useFullAuto = false;
    var i = this.zoomValues.indexOf(this.snap(this.zoom)) + 1;
    if (i < this.zoomValues.length)
      this.zoom = this.zoomValues[i];
  },

  reduce: function ZoomManager_reduce() {
    this.useFullAuto = false;
    var i = this.zoomValues.indexOf(this.snap(this.zoom)) - 1;
    if (i >= 0)
      this.zoom = this.zoomValues[i];
  },

  reset: function ZoomManager_reset() {
    this.useFullAuto = false;
    this.zoom = FullZoom.globalValue;
  },

  toggleZoom: function ZoomManager_toggleZoom() {
    this.useFullAuto = false;
    var zoomLevel = this.zoom;

    this.useFullZoom = !this.useFullZoom;
    this.zoom = zoomLevel;
  },

  snap: function ZoomManager_snap(aVal) {
    var values = this.zoomValues;
    for (var i = 0; i < values.length; i++) {
      if (values[i] >= aVal) {
        if (i > 0 && aVal - values[i - 1] < values[i] - aVal)
          i--;
        return values[i];
      }
    }
    return values[i - 1];
  },
}
